<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\MenuLocation;

/**
 * MenuLocationSearch represents the model behind the search form about `backend\models\MenuLocation`.
 */
class MenuLocationSearch extends MenuLocation
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['menu_location_id'], 'integer'],
            [['menu_location_name'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = MenuLocation::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'menu_location_id' => $this->menu_location_id,
        ]);

        $query->andFilterWhere(['like', 'menu_location_name', $this->menu_location_name]);

        return $dataProvider;
    }
}
